"use strict";

var _toConsumableArray = function (arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i]; return arr2; } else { return Array.from(arr); } };

var getListLevel = (function (_getListLevel) {
  function getListLevel(_x) {
    return _getListLevel.apply(this, arguments);
  }

  getListLevel.toString = function () {
    return _getListLevel.toString();
  };

  return getListLevel;
})(function (list) {
  var numList = list.map(function (item) {
    return Array.isArray(item) ? getListLevel(item) + 1 : 1;
  });
  return Math.max.apply(Math, _toConsumableArray(numList));
});

var makeSpace = (function (_makeSpace) {
  function makeSpace(_x2, _x3) {
    return _makeSpace.apply(this, arguments);
  }

  makeSpace.toString = function () {
    return _makeSpace.toString();
  };

  return makeSpace;
})(function (buffer, n) {
  return n > 0 ? makeSpace(buffer + " ", n - 1) : buffer;
});

exports.spaces = function (n) {
  return makeSpace("", n);
};

exports.type = function (x) {
  var info = Object.prototype.toString.call(x),
      theType = info.slice(8, -1);
  return theType.toLowerCase();
};

exports.markToken = function (text) {
  if (text.match(/^[^\"\s$\(\)]+$/)) {
    return text;
  } else {
    return JSON.stringify(text);
  }
};

exports.isPlain = function (list) {
  return list.every(function (child) {
    return exports.type(child) === "string";
  });
};

exports.isArray = function (x) {
  return exports.type(x) === "array";
};

exports.isDeep = function (ast) {
  if (Array.isArray(ast)) {
    var level = getListLevel(ast);
    return level > 2;
  } else {
    return false;
  }
};

var trimRightSpace = (function (_trimRightSpace) {
  function trimRightSpace(_x4) {
    return _trimRightSpace.apply(this, arguments);
  }

  trimRightSpace.toString = function () {
    return _trimRightSpace.toString();
  };

  return trimRightSpace;
})(function (text) {
  var end = text.length - 1,
      last = text[end];

  if (last === " ") {
    return trimRightSpace(text.substr(0, end));
  } else {
    return text;
  }
});

exports.trimRightSpace = function (text) {
  return trimRightSpace(text);
};